diff --git a/app/test-pmd/cmdline_flow.c b/app/test-pmd/cmdline_flow.c
index a9e4f56ba..18a7b4734 100644
--- a/app/test-pmd/cmdline_flow.c
+++ b/app/test-pmd/cmdline_flow.c
@@ -195,6 +195,14 @@ enum index {
 	ACTION_VF_ID,
 	ACTION_METER,
 	ACTION_METER_ID,
+	ACTION_OF_MPLS_TTL_SET,
+	ACTION_OF_MPLS_TTL_SET_TTL,
+	ACTION_OF_MPLS_TTL_DEC,
+	ACTION_OF_IP_TTL_SET,
+	ACTION_OF_IP_TTL_SET_TTL,
+	ACTION_OF_IP_TTL_DEC,
+	ACTION_OF_TTL_COPY_OUT,
+	ACTION_OF_TTL_COPY_IN,
 };
 
 /** Size of pattern[] field in struct rte_flow_item_raw. */
@@ -668,6 +676,12 @@ static const enum index next_action[] = {
 	ACTION_PF,
 	ACTION_VF,
 	ACTION_METER,
+	ACTION_OF_MPLS_TTL_SET,
+	ACTION_OF_MPLS_TTL_DEC,
+	ACTION_OF_IP_TTL_SET,
+	ACTION_OF_IP_TTL_DEC,
+	ACTION_OF_TTL_COPY_OUT,
+	ACTION_OF_TTL_COPY_IN,
 	ZERO,
 };
 
@@ -708,6 +722,18 @@ static const enum index action_meter[] = {
 	ZERO,
 };
 
+static const enum index action_of_mpls_ttl_set[] = {
+	ACTION_OF_MPLS_TTL_SET_TTL,
+	ACTION_NEXT,
+	ZERO,
+};
+
+static const enum index action_of_ip_ttl_set[] = {
+	ACTION_OF_IP_TTL_SET_TTL,
+	ACTION_NEXT,
+	ZERO,
+};
+
 static int parse_init(struct context *, const struct token *,
 		      const char *, unsigned int,
 		      void *, unsigned int);
@@ -1857,6 +1883,66 @@ static const struct token token_list[] = {
 		.args = ARGS(ARGS_ENTRY(struct rte_flow_action_meter, mtr_id)),
 		.call = parse_vc_conf,
 	},
+	[ACTION_OF_MPLS_TTL_SET] = {
+		.name = "of_mpls_ttl_set",
+		.help = "set MPLS TTL",
+		.priv = PRIV_ACTION(OF_MPLS_TTL_SET,
+			sizeof(struct rte_flow_action_of_mpls_ttl_set)),
+		.next = NEXT(action_of_mpls_ttl_set),
+		.call = parse_vc,
+	},
+	[ACTION_OF_MPLS_TTL_SET_TTL] = {
+		.name = "ttl",
+		.help = "new TTL to set",
+		.next = NEXT(action_of_mpls_ttl_set, NEXT_ENTRY(UNSIGNED)),
+		.args = ARGS(ARGS_ENTRY(struct rte_flow_action_of_mpls_ttl_set,
+					ttl)),
+		.call = parse_vc_conf,
+	},
+	[ACTION_OF_MPLS_TTL_DEC] = {
+		.name = "of_mpls_ttl_dec",
+		.help = "decrement MPLS TTL",
+		.priv = PRIV_ACTION(OF_MPLS_TTL_DEC, 0),
+		.next = NEXT(NEXT_ENTRY(ACTION_NEXT)),
+		.call = parse_vc,
+	},
+	[ACTION_OF_IP_TTL_SET] = {
+		.name = "of_ip_ttl_set",
+		.help = "set IP TTL",
+		.priv = PRIV_ACTION(OF_IP_TTL_SET,
+			sizeof(struct rte_flow_action_of_ip_ttl_set)),
+		.next = NEXT(action_of_ip_ttl_set),
+		.call = parse_vc,
+	},
+	[ACTION_OF_IP_TTL_SET_TTL] = {
+		.name = "ttl",
+		.help = "new TTL to set",
+		.next = NEXT(action_of_ip_ttl_set, NEXT_ENTRY(UNSIGNED)),
+		.args = ARGS(ARGS_ENTRY(struct rte_flow_action_of_ip_ttl_set,
+					ttl)),
+		.call = parse_vc_conf,
+	},
+	[ACTION_OF_IP_TTL_DEC] = {
+		.name = "of_ip_ttl_dec",
+		.help = "decrement IPv4 TTL or IPv6 Hop Limit",
+		.priv = PRIV_ACTION(OF_IP_TTL_DEC, 0),
+		.next = NEXT(NEXT_ENTRY(ACTION_NEXT)),
+		.call = parse_vc,
+	},
+	[ACTION_OF_TTL_COPY_OUT] = {
+		.name = "of_ttl_copy_out",
+		.help = "copy TTL outwards",
+		.priv = PRIV_ACTION(OF_TTL_COPY_OUT, 0),
+		.next = NEXT(NEXT_ENTRY(ACTION_NEXT)),
+		.call = parse_vc,
+	},
+	[ACTION_OF_TTL_COPY_IN] = {
+		.name = "of_ttl_copy_in",
+		.help = "copy TTL inwards",
+		.priv = PRIV_ACTION(OF_TTL_COPY_IN, 0),
+		.next = NEXT(NEXT_ENTRY(ACTION_NEXT)),
+		.call = parse_vc,
+	},
 };
 
 /** Remove and return last entry from argument stack. */
diff --git a/doc/guides/prog_guide/rte_flow.rst b/doc/guides/prog_guide/rte_flow.rst
index cfa790417..7b07fe791 100644
--- a/doc/guides/prog_guide/rte_flow.rst
+++ b/doc/guides/prog_guide/rte_flow.rst
@@ -1574,6 +1574,106 @@ fields in the pattern items.
    | 1     | END      |
    +-------+----------+
 
+Action: ``OF_MPLS_TTL_SET``
+^^^^^^^^^^^^^^^^^^^^^^^^^^^
+
+Replace MPLS TTL, only applies to packets that contain MPLS
+headers. Comply with OpenFlow action "OFPAT_SET_MPLS_TTL".
+
+.. _table_rte_flow_action_of_mpls_ttl_set:
+
+.. table:: OF_MPLS_TTL_SET
+
+   +---------+---------------------+
+   | Field   | Value               |
+   +=========+=====================+
+   | ``ttl`` | new MPLS TTL to set |
+   +---------+---------------------+
+
+Action: ``OF_MPLS_TTL_DEC``
+^^^^^^^^^^^^^^^^^^^^^^^^^^^
+
+Decrement MPLS TTL, only applies to packets that contain MPLS
+headers, Comply with OpenFlow action "OFPAT_DEC_MPLS_TTL".
+
+.. _table_rte_flow_action_of_mpls_ttl_dec:
+
+.. table:: OF_MPLS_TTL_DEC
+
+   +---------------+
+   | Field         |
+   +===============+
+   | no properties |
+   +---------------+
+
+Action: ``OF_IP_TTL_SET``
+^^^^^^^^^^^^^^^^^^^^^^^^^
+
+Replace IPv4 TTL or IPv6 Hop Limit field and update the IP checksum,
+only applies to packets that contain MPLS headers. Comply with OpenFlow
+action "OFPAT_DEC_NW_TTL".
+
+.. _table_rte_flow_action_of_ip_ttl_set:
+
+.. table:: OF_IP_TTL_SET
+
+   +---------+---------------------------------------+
+   | Field   | Value                                 |
+   +=========+=======================================+
+   | ``ttl`` | new IPv4 TTL or IPv6 Hot Limit to set |
+   +---------+---------------------------------------+
+
+Action: ``OF_IP_TTL_DEC``
+^^^^^^^^^^^^^^^^^^^^^^^^^
+
+Decrement IPv4 TTL or IPv6 Hop Limit field and update the IP checksum,
+only applies to packets that contain MPLS headers. Comply with OpenFlow
+action "OFPAT_DEC_NW_TTL".
+
+.. _table_rte_flow_action_of_ip_ttl_dec:
+
+.. table:: OF_IP_TTL_DEC
+
+   +---------------+
+   | Field         |
+   +===============+
+   | no properties |
+   +---------------+
+
+Action: ``OF_TTL_COPY_OUT``
+^^^^^^^^^^^^^^^^^^^^^^^^^^^
+
+Copy the TTL from next-to-outermost to outermost header with TTL, copy can
+be IP to IP, MPLS to MPLS or IP to MPLS, only applies packets that contain
+required MPLS or IP headers. Comply with OpenFlow action "OFPAT_COPY_TTL_OUT".
+
+.. _table_rte_flow_action_of_ttl_copy_out:
+
+.. table:: OF_TTL_COPY_OUT
+
+   +---------------+
+   | Field         |
+   +===============+
+   | no properties |
+   +---------------+
+
+Action: ``OF_TTL_COPY_IN``
+^^^^^^^^^^^^^^^^^^^^^^^^^^
+
+Copy the TTL from outermost to next-to-outermost header with TTL, copy can
+be IP to IP, MPLS to MPLS or MPLS to IP, only applies packets that contain
+required MPLS or IP headers. Comply with OpenFlow action "OFPAT_COPY_TTL_IN".
+
+.. _table_rte_flow_action_of_ttl_copy_in:
+
+.. table:: OF_TTL_COPY_IN
+
+   +---------------+
+   | Field         |
+   +===============+
+   | no properties |
+   +---------------+
+
 Negative types
 ~~~~~~~~~~~~~~
 
diff --git a/doc/guides/testpmd_app_ug/testpmd_funcs.rst b/doc/guides/testpmd_app_ug/testpmd_funcs.rst
index d2d084bb2..c1bc53741 100644
--- a/doc/guides/testpmd_app_ug/testpmd_funcs.rst
+++ b/doc/guides/testpmd_app_ug/testpmd_funcs.rst
@@ -3449,6 +3449,22 @@ This section lists supported actions and their attributes, if any.
   - ``original {boolean}``: use original VF ID if possible.
   - ``id {unsigned}``: VF ID to redirect packets to.
 
+- ``of_mpls_ttl_set``: set MPLS TTL (note: OpenFlow comply).
+
+  - ``ttl``: new TTL to set.
+
+- ``of_mpls_ttl_dec``: decrement MPLS TTL (note: OpenFlow comply).
+
+- ``of_ip_ttl_set``: set IPv4 TTL or IPv6 Hot Limit (note: OpenFlow comply).
+
+  - ``ttl``: new TTL to set.
+
+- ``of_ip_ttl_dec``: decrement IPv4 TTL or IPv6 Hot Limit (note: OpenFlow comply).
+
+- ``of_ttl_copy_out``: copy TTL outwards (note: OpenFlow comply).
+
+- ``of_ttl_copy_in``: copy TTL inwards (note: OpenFlow comply).
+
 Destroying flow rules
 ~~~~~~~~~~~~~~~~~~~~~
 
diff --git a/lib/librte_ether/rte_flow.h b/lib/librte_ether/rte_flow.h
index 25581513d..72819abd2 100644
--- a/lib/librte_ether/rte_flow.h
+++ b/lib/librte_ether/rte_flow.h
@@ -1245,7 +1245,62 @@ enum rte_flow_action_type {
 	 *
 	 * See struct rte_flow_action_security.
 	 */
-	RTE_FLOW_ACTION_TYPE_SECURITY
+	RTE_FLOW_ACTION_TYPE_SECURITY,
+
+	/**
+	 * Replace MPLS TTL, only applies to packets that contain
+	 * MPLS header. Comply with OpenFlow action "OFPAT_SET_MPLS_TTL".
+	 *
+	 * See struct rte_flow_action_of_mpls_ttl_set.
+	 */
+	RTE_FLOW_ACTION_TYPE_OF_MPLS_TTL_SET,
+
+
+	/**
+	 * Decrement MPLS TTL, only applies to packets that contain
+	 * MPLS header. Comply with OpenFlow action "OFPAT_DEC_MPLS_TTL".
+	 *
+	 * No associated configuration structure.
+	 */
+	RTE_FLOW_ACTION_TYPE_OF_MPLS_TTL_DEC,
+
+	/**
+	 * Replace IPv4 TTL or IPv6 Hop Limit field and update the IP
+	 * checksum, only applies to packets that contain IPv4 or IPv6
+	 * header. Comply with OpenFlow action "OFPAT_SET_NW_TTL".
+	 *
+	 * See struct rte_flow_action_of_ip_ttl_set.
+	 */
+	RTE_FLOW_ACTION_TYPE_OF_IP_TTL_SET,
+
+	/**
+	 * Decrement IPv4 TTL or IPv6 Hop Limit field and update the IP
+	 * checksum, only applies to packets that contain IPv4 or IPv6
+	 * header. Comply with OpenFlow action "OFPAT_DEC_NW_TTL".
+	 *
+	 * No associated configuration structure.
+	 */
+	RTE_FLOW_ACTION_TYPE_OF_IP_TTL_DEC,
+
+	/**
+	 * Copy the TTL from next-to-outermost to outermost header with TTL,
+	 * copy can be IP to IP, MPLS to MPLS or IP to MPLS, only applies
+	 * packets that contain required protocol headers. Comply with OpenFlow
+	 * action "OFPAT_COPY_TTL_OUT".
+	 *
+	 * No associated configuration structure.
+	 */
+	RTE_FLOW_ACTION_TYPE_OF_TTL_COPY_OUT,
+
+	/**
+	 * Copy the TTL from outermost to next-to-outermost header with TTL,
+	 * copy can be IP to IP, MPLS to MPLS or MPLS to IP, only applies
+	 * packets that contain required protocol headers. Comply with OpenFlow
+	 * action "OFPAT_COPY_TTL_IN".
+	 *
+	 * No associated configuration structure.
+	 */
+	RTE_FLOW_ACTION_TYPE_OF_TTL_COPY_IN,
 };
 
 /**
@@ -1384,6 +1439,27 @@ struct rte_flow_action_security {
 };
 
 /**
+ * RTE_FLOW_ACTION_TYPE_OF_MPLS_TTL_SET
+ *
+ * Replace MPLS TTL, only applies to packets that contain MPLS header.
+ * Comply with OpenFlow action "OFPAT_SET_MPLS_TTL".
+ */
+struct rte_flow_action_of_mpls_ttl_set {
+	uint8_t ttl; /**< New TTL to set */
+};
+
+/**
+ * RTE_FLOW_ACTION_TYPE_OF_IP_TTL_SET
+ *
+ * Replace IPv4 TTL or IPv6 Hop Limit field and update the IP
+ * checksum, only applies to packets that contain IPv4 or IPv6
+ * header. Comply with OpenFlow action "OFPAT_SET_NW_TTL".
+ */
+struct rte_flow_action_of_ip_ttl_set {
+	uint8_t ttl; /**< New TTL or Hop Limit to set */
+};
+
+/**
  * Definition of a single action.
  *
  * A list of actions is terminated by a END action.